/*particleEffects.c
 *
 * does like the title says :)
 */




#include <stdio.h>
#include "game.h"

void createParticleEffect (SDL_Surface *pscreen, SDL_Surface *ptarget, SDL_Surface *pbackground, int origx, int origy, int whichParticleEffect) {

	SDL_Rect src={0,0,1,1},	trollsrc={4,155,2,2}, dst;
	static particleEffect explosion[21];
	static int new=20;
	int where=0, i, j, px ;
	
	while(new!=-1) {
		
		explosion[new].x=0;
		explosion[new].y=0;
		explosion[new].rightside=1; 
		explosion[new].whichEffect=0;
		explosion[new].w=0;
		explosion[new].h=0;
		explosion[new].stage=0;
		explosion[new].whichParticleArray=0;
		explosion[new].bounce=0;	
		for(i=0;i<61;i++) {
			explosion[new].putx[i]=0;
			explosion[new].puty[i]=0;
		}
		
		
		
		new--;

	}
	

	switch(whichParticleEffect) {

		case 0: // create troll explosion
			while(explosion[where].stage) where++;
			explosion[where].x=origx;
			explosion[where].y=origy;
			explosion[where].whichEffect=2;
			explosion[where].stage=120;
			for(px=0;px<61;px++){
				explosion[where].putx[px]=origx+rand()%20;
                       		explosion[where].puty[px]=origy+30;
                       		explosion[where].bounce=0;
                      	}

			break;





		
		case 1:
		
			while(explosion[where].stage) where++;//check where in the particleeffect array there is empty space to put new effect

			explosion[where].x=origx;
			explosion[where].y=origy;
			if (origy>450){ //if heart is touching the earth then do a heart explosion instead
				explosion[where].whichEffect=1;
				explosion[where].stage=120;
				for(px=0;px<61;px++){
					explosion[where].putx[px]=origx+rand()%30;
					explosion[where].puty[px]=origy+30;
					explosion[where].bounce=0;
				}
			
			
			}else {
				explosion[where].whichEffect=0;
				explosion[where].stage=30;
			}
			break;
		case 2:

			for(i=0;i<11;i++){ //check which spot the effect is in
				if(explosion[i].stage){ 
				
					switch(explosion[i].whichEffect) {
						case 0:		//for heart to heart collision
							dst.x=explosion[i].x; //clear the pixel effect area
							dst.y=explosion[i].y;                             		
							dst.w=30;                          		
							dst.h=dst.w;                          		
							SDL_BlitSurface(pbackground, &dst, pscreen, &dst);		
							for(j=60;j>0;j--){ //draw 30 pixels each side
								if(explosion[i].rightside) { //do right side
									dst.x=15+explosion[i].x+rand()%(16-explosion[i].stage/2);
									explosion[i].rightside=0;
								}
								else{ //do left side
									dst.x=15+explosion[i].x-rand()%(16-explosion[i].stage/2);
									explosion[i].rightside=1;
								}
								dst.y=explosion[i].y+rand()%(31-explosion[i].stage);
								dst.w=31-explosion[i].stage;
								dst.h=dst.w;
								SDL_BlitSurface(ptarget, &src, pscreen, &dst);
								
							}
						explosion[i].stage--;
						if(!explosion[i].stage) {
							dst.w=32;
							dst.h=dst.w;
							dst.x=explosion[i].x-1;
							dst.y=explosion[i].y;
							SDL_BlitSurface(pbackground, &dst, pscreen, &dst);
						}
						
					
						break;
						
						case 1:	//for heart to earth collision

							
						 //clear the pixel effect area, has to be -40 because the width of the explosion is wider than the width of the heart.
						
						
							for (j=0;j<61;j++) {
								dst.x=explosion[i].putx[j];
								dst.y=explosion[i].puty[j];
								dst.w=1;
								dst.h=dst.w;
								SDL_BlitSurface(pbackground, &dst, pscreen, &dst);
							}
						
							for(j=0;j<61;j++){ //draw 30 pixels each side   
								
								//if(explosion[i].)explosion[i].puty[j]-=rand()%2;
								if(explosion[i].y>=explosion[i].puty[j]){
									explosion[i].bounce=1;
								}
								if(explosion[i].bounce){
									explosion[i].puty[j]+=rand()%4;
								}
								else	explosion[i].puty[j]-=rand()%4;
								
								if (j%2){ //which way the pixels should go
									explosion[i].putx[j]+=rand()%2;
								}else explosion[i].putx[j]-=rand()%2;
								dst.x=explosion[i].putx[j];
								dst.y=explosion[i].puty[j];
								SDL_BlitSurface(ptarget, &src, pscreen, &dst);
							} 
								/*dst.y=explosion[i].y+rand()%(31-explosion[i].stage/4); 
								dst.w=121-explosion[i].stage; 
								dst.h=30; 
								SDL_BlitSurface(ptarget, &src, pscreen, &dst); */
							                                                                        						
						explosion[i].stage--; 
						if(!explosion[i].stage) { 
							dst.w=121; 
							dst.h=30;
							dst.x=explosion[i].x-1;   						
							dst.y=explosion[i].y; 
							SDL_BlitSurface(pbackground, &dst, pscreen, &dst); 
						}                                     						
						break;
					
						case 2:
							

						
							for (j=0;j<61;j++) {                                                                                                    								
					        		dst.x=explosion[i].putx[j];
					        		dst.y=explosion[i].puty[j];
					        		dst.w=2;
					        		dst.h=dst.w;
				                		SDL_BlitSurface(pbackground, &dst, pscreen, &dst);
                                                	}
                                                
                                                	for(j=0;j<61;j++){ //draw 30 pixels each side   
                                                		
                                                		if(explosion[i].y>=explosion[i].puty[j]){
                                                			explosion[i].bounce=1;
                                                		}
                                                		if(explosion[i].bounce){
                                                			explosion[i].puty[j]+=rand()%4;
                                                		}
                                                		else	explosion[i].puty[j]-=rand()%4;
                                                		
                                                		if (j%2){ //which way the pixels should go
                                                			explosion[i].putx[j]+=rand()%2;
                                                		}else explosion[i].putx[j]-=rand()%2;
                                                		dst.x=explosion[i].putx[j];
                                                		dst.y=explosion[i].puty[j];
                                                		SDL_BlitSurface(ptarget, &trollsrc, pscreen, &dst);
                                                	} 
                                                		/*dst.y=explosion[i].y+rand()%(31-explosion[i].stage/4); 
                                                		dst.w=121-explosion[i].stage; 
                                                		dst.h=30; 
                                                		SDL_BlitSurface(ptarget, &src, pscreen, &dst); */
                                                	                                                                        						
                                                explosion[i].stage--; 
                                                if(!explosion[i].stage) { 
                                                	dst.w=121; 
                                                	dst.h=30;
                                                	dst.x=explosion[i].x-1;   						
                                                	dst.y=explosion[i].y; 
                                                	SDL_BlitSurface(pbackground, &dst, pscreen, &dst); 
                                                }                                     						
                                                break;

						
					}
				}
					
			
			}
			
			
			break;















			



	}

	





				
}

